open ExtString;;

let file_lines fname = 
  let ic = open_in fname in let lines = Std.input_list ic in close_in ic; lines;;
  
let encode s =
  let letters = "ejnqrwxdsyftamcivbkulopghz" 
  and digits  = "01112223334455666777888999" in
  let mapper c = try let j = String.index letters c in String.sub digits j 1 with Not_found->""
  in String.replace_chars mapper (String.lowercase s);;
  
let dict = Hashtbl.create 100;;
List.iter (fun s->Hashtbl.add dict (encode s) s) (file_lines "dict.txt");;

let (>>) f g = g f;;

let find str =
  Enum.init (String.length str) (fun i->String.sub str 0 (i+1)) >>
  Enum.map (fun s->List.map (fun w-> (w, String.length (encode w))) (Hashtbl.find_all dict s)) >>
  Enum.fold (@) [];;
  
let process phone =
  let rec trans str res dig_used =
    if str = "" then (if res<>"" then Printf.printf "%s:%s\n" phone res) else
    let vars = find str in
    if vars = [] then
      (if dig_used then () else trans (String.lchop str) (res^" "^(String.of_char str.[0]))  true)
    else List.iter (fun (word,k)-> 
                    trans (String.sub str k (String.length str - k)) (res ^ " " ^ word) false ) vars 
  in
  let ps = String.replace_chars (function '0'..'9' as c-> String.of_char c |_->"") phone in
  trans ps "" false;;  
  
List.iter process (file_lines "phones.txt");;